/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or
 *	implied, as to its fitness for any particular use.
 *
 *
 *	EOModelBrowserCell
 *
 *	Inherits From:		NXBrowserCell
 *
 *	Conforms To:		None
 *
 *	Declared In:		EOModelBrowserCell.h
 *
 *------------------------------------------------------------------------*/

#import <appkit/appkit.h>



@interface EOModelBrowserCell : NXBrowserCell
{
	int
		tag;
	NXColor
		textColor;
	BOOL
		isRelationship,
		isToManyRelationship;
}

/*--------------------------------------------------------------------------
 *	Initialization
 *------------------------------------------------------------------------*/
- initTextCell: (const char *) aString;


/*--------------------------------------------------------------------------
 *	Drawing
 *------------------------------------------------------------------------*/
- drawInside: (const NXRect *) cellFrame
	inView: controlView;
- highlight: (const NXRect *) cellFrame
	inView: controlView
	lit: (BOOL) flag;


/*--------------------------------------------------------------------------
 *	Accessors
 *------------------------------------------------------------------------*/
- (NXColor) textColor;
- setTextColor: (NXColor) aColor;
- setTag: (int) theTag;
- (int) tag;


/*--------------------------------------------------------------------------
 *	Setting Relationship Degree
 *------------------------------------------------------------------------*/
- setIsRelationship: (BOOL) flag;
- setIsToManyRelationship: (BOOL) flag;


/*--------------------------------------------------------------------------
 *	Setting Text Attributes
 *------------------------------------------------------------------------*/
- setTextAttributes: aTextObject;

@end
