// -------------------------------------------------------------------------------------
//	BooleanFormatter.h
//  This software is without warranty of any kind.  Use at your own risk.
// -------------------------------------------------------------------------------------

#import <appkit/appkit.h>
#import <dbkit/dbkit.h>

// -------------------------------------------------------------------------------------
@interface BoolFormatter : DBFormatter
{

	id						drawCell;
	DBValue					*newValue;
	int						selectionMode;
	
}

// -------------------------------------------------------------------------------------

- init;
- free;

- setMode:(int)newMode;
- (int)mode;

- setImage:anImage;
- image;
- setIcon:(const char*)anIcon;
- (const char*)icon;
- setAltImage:anImage;
- altImage;
- setAltIcon:(const char*)anIcon;
- (const char*)altIcon;

- drawFieldAt:(u_int) row :(u_int) column inside:(NXRect*)frame inView:view
	withAttributes:(id <DBTableVectors>)rowAttrs :(id <DBTableVectors>)columnAttrs
	usePositions:(BOOL) useRowPos :(BOOL) useColumnPos;
- mouseDown:(NXEvent *)theEvent at:(int)row :(int)column
	inside:(NXRect *)frame inView:(View *)view
	withAttributes:(id <DBTableVectors>)rowAttrs :(id <DBTableVectors>)columnAttrs
	usePositions:(BOOL) useRowPos :(BOOL) useColumnPos;

- setValueAt:(int)row :(int)column
    withAttributes:(id <DBTableVectors >)rowAttrs :(id <DBTableVectors >)columnAttrs
    usePositions:(BOOL)useRowPos :(BOOL)useColumnPos;

- write:(NXTypedStream*)stream;
- read:(NXTypedStream*)stream;

@end
