/**------------------------------------*------------------------------------**
    RELEASED TO THE PUBLIC DOMAIN BY CODEWORKS DEVELOPMENT, DECEMBER 1993.
    You may freely copy, distribute and reuse the code in this example. Codeworks disclaims any warranty of any kind, expressed or implied, as to its fitness for any particular use.
    Author:  Andrew Vyrros, av@codeworks.com
 **------------------------------------*------------------------------------**/
/**------------------------------------*------------------------------------**
    File:    Doodle.m
    Project: DynaDoodle
    Info:    Implementation of the Doodle class. Doodle is a subclass of View for creating arbitrary silly drawings. Doodle implements the basic behavior of setting foreground an background colors and loading a nib with custom controls. Subclasses, which are loaded from dynamic modules, provide the specific drawing functionality.
 **------------------------------------*------------------------------------**/

#import <appkit/View.h>


@interface Doodle:View
{
  NXColor             foregroundColor;   // color for foreground drawing
  NXColor             backgroundColor;   // color for background drawing
  id                  customControlView; // outlet to View containing special
                                         // controls, in {className}.nib
}

- initFrame:(const NXRect *)f;
- free;
- customControlView;
- loadNib;
- didLoadNib;
- drawSelf:(const NXRect *)rects :(int)numRects;
- setForegroundColor:(NXColor)c;
- setBackgroundColor:(NXColor)c;

@end
