/**------------------------------------*------------------------------------**
    RELEASED TO THE PUBLIC DOMAIN BY CODEWORKS DEVELOPMENT, DECEMBER 1993.
    You may freely copy, distribute and reuse the code in this example. Codeworks disclaims any warranty of any kind, expressed or implied, as to its fitness for any particular use.
    Author:  Andrew Vyrros, av@codeworks.com
 **------------------------------------*------------------------------------**/
/**------------------------------------*------------------------------------**
    File:    DoodleBundle.h
    Project: DynaDoodle
    Info:    Interface of the DoodleBundle class. DoodleBundle is a subclass of NXBundle designed specifically for managing dynamically loaded modules containing a single Doodle object. DoodleManager creates a single DoodleBundle instance for each doodle module that it finds in the Library directories. When asked for its Doodle, a DoodleBundle will dynamically load its code file, create an instance of its Doodle subclass, and then return the instance to DoodleManager.
 **------------------------------------*------------------------------------**/

#import <objc/NXBundle.h>

@class Doodle;


@interface DoodleBundle:NXBundle
{
  const char           *doodleName;  // UI string naming doodle
  const char           *doodleDescription;// UI string describing doodle
  Doodle               *doodle;      // doodle instance managed by DoodleBundle
}

- initForDirectory:(const char *)path;
- free;
- (const char *)doodleName;
- (const char *)doodleDescription;
- (Doodle *)doodle;

@end
