/**------------------------------------*------------------------------------**
    RELEASED TO THE PUBLIC DOMAIN BY CODEWORKS DEVELOPMENT, DECEMBER 1993.
    You may freely copy, distribute and reuse the code in this example. Codeworks disclaims any warranty of any kind, expressed or implied, as to its fitness for any particular use.
    Author:  Andrew Vyrros, av@codeworks.com
 **------------------------------------*------------------------------------**/
/**------------------------------------*------------------------------------**
    File:    Face.h
    Project: DynaDoodle/Face.bproj
    Info:    Interface of the Face class. Face is the principal class in the module. It uses EyePair and Mouth as helper classes. All that was required to add it to the other classes to this module was to drag them to the classes Browser in Project Builder. Face is free to use these classes as it needs. The only caveat is that Face.m must be the first class listed in PB's Classes browser. This makes Face the principal class of the module, so that DoodleBundle can find Face when it loads the code file.
 **------------------------------------*------------------------------------**/

#import "../Doodle.h"

@class EyePair, Mouth;


@interface Face:Doodle
{
  id                  pupilSizeSlider;
  id                  smileFactorSlider;
  float               pupilSize;
  float               smileFactor;
  EyePair            *eyePair;
  Mouth              *mouth;
}

- initFrame:(const NXRect *)f;
- didLoadNib;
- drawSelf:(const NXRect *)rects :(int)numRects;
- takePupilSizeFrom:sender;
- takeSmileFactorFrom:sender;

@end
