/*
 * Author: Greg Burd, Mr. Average Developer
 *    (I would like to be a member of the NeXT Developer Support Team.)
 *
 * You may freely copy, distribute and reuse the code in this example.  
 * I disclaim any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 */

#import <appkit/View.h>

@interface SwapView:View
{
	id		lastInspector;
	id		currentInspector;
	id		delegate;
	float	backgroundGray;
}

- init;
- initFrame:(NXRect *)frame;
- delegate;
- setDelegate:(id)anObject;
- (float)backgroundGray;
- setBackgroundGray:(float)aColor;
- currentInspector;
- lastInspector;
- swapIt:sender;
- swapIt;
- free;

@end
/*---------------------------------------------------------------------------*/
/* DELEGATE NEEDS TO ANSWER 

- whatPanel		<-  This has the id of the loaded panel.  That panel's
					contentView is used as the inspector.  The panel's
					frame should be the same size as the SwapView.
						
So below we have set up a dummy interface declaration so we don't get
a complier error, and we can send a
	[delegate respondsTo:@selector(whatPanel)];
And make sure that the delegate has the method. Stability, known state, etc...
*/

@interface someDelegate:Object

- whatPanel;

@end

