// MOController.h
//
// by Mike Ferris
// Part of MOKit
// Copyright 1993, all rights reserved.

// ABOUT MOKit
// 
// MOKit is a collection of useful and general objects.  Permission is 
// granted by the author to use MOKit in your own programs in any way 
// you see fit.  All other rights to the kit are reserved by the author 
// including the right to sell these objects as part of a LIBRARY or as 
// SOURCE CODE.  In plain English, I wish to retain rights to these 
// objects as objects, but allow the use of the objects as pieces in a 
// fully functional program.  NO WARRANTY is expressed or implied.  The author 
// will under no circumstances be held responsible for ANY consequences to 
// you from the use of these objects.  Since you don't have to pay for 
// them, and full source is provided, I think this is perfectly fair.

// ABOUT MOController
//
// MOController provides basic one-window nib-management.  That is, a 
// subclass of MOController makes a good owner for a nib file which 
// contains one main window.  The controller stores the name of the nib 
// file and the name to save the frame of the window under.  The 
// -showWindow:sender method puts the window on screen, loading it from 
// the nib first if necessary.

#import <appkit/appkit.h>

// Forward declarations of class names we'll use for static typing.
@class MOString;

@interface MOController:Object
{
	id window;				// IB outlet
	MOString *frameName;
	
	BOOL nibIsLoaded;
}

+ initialize;

+ setClassNib:(const char *)nibName;
+ (const char *)classNib;

+ startUnloading;

- init;
- initWithFrameName:(const char *)theFrameName;
- free;

- setFrameName:(const char *)theFrameName;
- (const char *)frameName;

- nibDidLoad;
- loadNibIfNeeded;

- window;
- window:(BOOL)loadFlag;
- showWindow:sender;

@end

