// MOTestDocManager.m
//
// by Mike Ferris
// Part of MOKit
// Copyright 1993, all rights reserved.

#import "MOTestDocManager.h"
#import "MOTextDocController.h"
#import "MOImageDocController.h"

#define CLASS_VERSION			0

@implementation MOTestDocManager

+ initialize
// Set the version.
{
	if (self == [MOTestDocManager class])  {
		[self setVersion:CLASS_VERSION];
	}
	return self;
}

- init
{
	[self initDocumentClass:[MOTextDocController class]];
	[self addDocumentClass:[MOImageDocController class]];
	
	return self;
}

#define SHOW_RULER_STRING			"Show Ruler"
#define HIDE_RULER_STRING			"Hide Ruler"

- toggleRuler:sender
{
	id fr = [[NXApp keyWindow] firstResponder];
	if ([fr respondsTo:@selector(toggleRuler:)])  {
		[fr toggleRuler:sender];
	}  else  {
		return nil;
	}
	if (currentDoc)  {
		if ([[(MOTextDocController *)currentDoc textObj] isRulerVisible])  {
			[[sender selectedCell] setTitle:HIDE_RULER_STRING];
		}  else  {
			[[sender selectedCell] setTitle:SHOW_RULER_STRING];
		}
		[sender display];
	}
	return self;
}


@end
