# links.make
# by Mike Ferris
# Originally part of MOKit; modified by Don Yacktman for
# use in the MiscKit
# Copyright 1993, 1995, all rights reserved

# About links.make
#
# This makefile provides a target which will create soft links to
# all the files listed in the make variable SOFTLINKS.
#
# This makefile should be included from the project's Makefile.postamble.
# The Makefile.preamble should add the line "all:: links" to the end
# and should define SOFTLINKS to be a list of files that need to be linked.

LINK_ECHO = echo
LINK_LN_S = /bin/ln -s

links:
	@if [ "$(SOFTLINKS)" ] ; then \
		$(LINK_ECHO) "Making soft links to $(SOFTLINKS)..." ; \
		for i in `/bin/ls -d $(SOFTLINKS)` ; do \
			if [ ! -r `basename $$i` ] ; then \
				$(LINK_LN_S) $$i . ; \
			fi ; \
		done ; \
	fi

