//
//	MiscClipTextFieldCell.h -- a cell for displaying long string values
//		Written and Copyright (c) 1995 by Balazs Pataki. 
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/TextFieldCell.h>

@interface MiscClipTextFieldCell : TextFieldCell

{	
	id		delegate;
	
	id		fullString;
	id		clipper;
	id		delimiters;
	
	BOOL	clipOnRight;
	BOOL	clipEnabled;
}

- init;
- initTextCell:(const char*)aString;
- copyFromZone:(NXZone *)zone;

- free;

- setDelegate:anObject;

- setClipOnRight:(BOOL)flag;
- setClipperString:(const char*)aString;
- setClipDelimiters:(const char*)delimiters;
- setClipEnabled:(BOOL)flag;

- setStringValue:(const char *)aString;
- takeStringValueFrom:sender;
- resetStringValue:sender;

- (const char*) fullStringValue;
- clipper;
- delimiters;
- delegate;
- (BOOL) isWrapped;
- (BOOL) isClipEnabled;
- (BOOL) doesClipOnRight;

- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;
- awake;

@end

@interface Object (MiscClipDelegate)
- stringWillBeClipped:theString;
@end

@interface MiscClipTextFieldCell(IBStuff)
- (const char *)getInspectorClassName;
@end
