/* MiscTabActionCell.m 
 *
 * By Bill Edney, Sean Hill, Mark Onyschuk, and Art Isbell
 * Copyright (C) 1995.  Use governed by the MiscKit license.
 */

#import <appkit/ActionCell.h>

@class NXImage;

@interface MiscTabActionCell:ActionCell
{
@private
    NXCoord ascender, descender, tabHeight, tabBezierImageWidth;

}

// Methods Overridden From the Superclass
- initTextCell:(const char *)aString;
- awake;
- setFont:fontObj;

- drawInside:(const NXRect *)cellFrame inView:controlView;
- highlight:(const NXRect *)cellFrame inView:aView lit:(BOOL)flag;
- calcCellSize:(NXSize *)theSize inRect:(const NXRect *)aRect;
- (BOOL)trackMouse:(NXEvent *)theEvent
			inRect:(const NXRect *)cellFrame
			ofView:controlView;
- (BOOL)startTrackingAt:(const NXPoint *)startPoint inView:aView;

// Other Instance Methods
- finishInitializing;

// Accessor Methods
- (BOOL)isSelected;
@end