#ifndef __MiscTableScrollInspector_h
#define __MiscTableScrollInspector_h
//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableScrollInspector.h
//
//		Interface Builder inspector for MiscTableScroll.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableScrollInspector.h,v 1.3 95/10/03 23:20:07 zarnuk Exp $
// $Log:		MiscTableScrollInspector.h,v $
//	Revision 1.3  95/10/03	23:20:07  zarnuk
//	Now keeps internal "dirty" flag and only does work in
//	"-textDidEnd:endChar:" if the text is "dirty".	This
//	should suppress most of the -border:slotAtPosition:
//	sent to freed object errors from IB.
//	
//	Revision 1.2  95/10/01	15:09:21  sunshine
//	Can now set text, background, textH, and backgroundH colors via inspector.
//	
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <apps/InterfaceBuilder.h>
}
#import <misckit/MiscTableTypes.h>

@class Button, Matrix, NXColorWell, ScrollView, TextField;
class MiscTableBorder;

@interface MiscTableScrollInspector : IBInspector
	{
	Button*				autosizeSwitch;
	Button*				autoSortSwitch;
	Button*				borderPopUp;
	Button*				cellClassPopUp;
	Button*				constrainMaxSwitch;
	Button*				constrainMinSwitch;
	Button*				deleteButton;
	Button*				downButton;
	Button*				draggableSwitch;
	Button*				enabledSwitch;
	Button*				expandToDataSwitch;
	Button*				lazySwitch;
	Button*				modePopUp;
	Button*				sizableSwitch;
	Button*				sortTypePopUp;
	Button*				sortDirectionPopUp;
	Button*				titleModePopUp;
	Button*				titlesSwitch;
	Button*				upButton;
	Button*				userSizeableSwitch;
	Matrix*				slotScroll;
	TextField*			sizeField;
	TextField*			sizeMaxField;
	TextField*			sizeMinField;
	TextField*			titleField;
	TextField*			uniformSizeField;
	NXColorWell*		colorText;
	NXColorWell*		colorTextH;
	NXColorWell*		colorBack;
	NXColorWell*		colorBackH;
	int					slot;			// Currently selected slot, or -1.
	int					num_slots;		// Total number of columns.
	MiscBorderType		border_type;
	MiscTableBorder*	border;
	BOOL				dirty;
	}

- init;
- ok: sender;
- revert: sender;

@end

#endif	// __MiscTableScrollInspector_h
