//=============================================================================
//
//		Copyright (C) 1995 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableWell.M
//
//		View class that draws a well where a column/row laid before dragging
//		was started.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableWell.M,v 1.1 95/09/27 12:21:21 zarnuk Exp $
// $Log:		MiscTableWell.M,v $
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
#import "MiscTableWell.h"

extern "Objective-C" {
#import <appkit/graphics.h>
#import <dpsclient/wraps.h>
}

@implementation MiscTableWell

//-----------------------------------------------------------------------------
// - initFrame:
//-----------------------------------------------------------------------------
- initFrame: (NXRect const*) frameRect
	{
	[super initFrame:frameRect];
	[self setOpaque:YES];
	[self setClipping:NO];
	return self;
	}


//-----------------------------------------------------------------------------
// - drawSelf::
//
//		NOTE *1*: Should be filling 'rects' rather than 'bounds' but during
//				auto-scrolling I found that drawing 'rects' only was
//				insufficient.  It didn't fully cover the background as it
//				should have.  I don't know why, currently.
//-----------------------------------------------------------------------------
- drawSelf: (NXRect const*) rects : (int) nrects
	{
	float const MED_GRAY = 0.5;
	PSsetgray( MED_GRAY );
	NXRectFill( &bounds );		// NOTE *1*
	return self;
	}

@end
