/*=========================== MiscMathCoord.m ===============================*/
/* MiscMathCoord is an abstract superclass that supports creation of common
   mathematical coordinate systems.

   DMA Release 0.8, Copyright @1993 by Genesis Project, Ltd. All Rights
   Reserved. For further information on terms and conditions see
		the MiscKit license.

HISTORY
21-Mar-93  Dale Amon at GPL
	   Created.
*/

#import <misckit/miscgiskit.h>

@implementation MiscMathCoord

/*===========================================================================*/
/* Initialization methods */
/*===========================================================================*/
/* DESIGNATED INITIALIZER */

-initDescription: (char *) txt constants: anObject
 {return 
	[super initDescription: txt
		     converter: [MiscMathCoordConverter new]
		     constants: anObject];
 }


/*---------------------------------------------------------------------------*/
/* Block the designated initializer of our parent class */

-initDescription: (char *) txt
       converter: (id <MiscCoordConverterServer>) aConverter
       constants: anObject
 {	[self error:"  %s class should not be sent '%s' messages\n",
            [[self class] name], sel_getName(_cmd)];
	return self;
 }


@end
