/*

MiscAppIcon.m 1.0
Sean Luke
August 14, 1995
Donated to the MiscKit

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee, under the restrictions as noted 
in the MiscKit copyright notice, is hereby granted, provided that
the MiscKit copyright notice and this permission notice 
appear in all source copies, and that the author's name shall not
be used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of the author.  SEAN O. LUKE  MAKES NO REPRESENTATIONS ABOUT THE
ACCURACY OR SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  
IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.

*/


#import <misckit/MiscAppIcon.h>

@implementation Application (MiscAppIcon)

- appIconToWindow:(Window*)thisWindow
	{
	int appIcongstate;
	NXRect theFrame;
	
	// Straight from a SwapView example--sorry, but I don't have
	// the example any more, so I can't give credit.  :-(

	appIcongstate=[[NXApp appIcon] gState];
	[[[NXApp appIcon] contentView] getFrame:&theFrame];
	[[thisWindow contentView] lockFocus];
	PScomposite((float)theFrame.origin.x,
		(float)theFrame.origin.y,
		(float)theFrame.size.width,
		(float)theFrame.size.height,
		(int)appIcongstate,
		(float)0.0,
		(float)0.0,
		(int)NX_COPY);
	[[thisWindow contentView] unlockFocus];
	[thisWindow flushWindow];
	NXPing();
	return self;
	}

- cleanTileToWindow:(Window*)thisWindow
	{
	NXPoint	contentViewOrigin = { 0.0, 0.0 };
	
	[[thisWindow contentView] lockFocus];
	[[NXImage findImageNamed: "NXAppTile"]
		composite:NX_SOVER toPoint:&contentViewOrigin];
	[[thisWindow contentView] unlockFocus];
	return self;
	}
	
	
- cleanTileToAppIcon
	{
	NXPoint	contentViewOrigin = { 0.0, 0.0 };
	
	[[[NXApp appIcon] contentView] lockFocus];
	[[NXImage findImageNamed: "NXAppTile"]
		 composite:NX_SOVER toPoint:&contentViewOrigin];
	[[[NXApp appIcon] contentView] unlockFocus];
	[[NXApp appIcon] flushWindow];
	NXPing();
	return self;
	}

- windowToAppIcon:(Window*)thisWindow
	{
	int thisWindowgstate;
	NXRect theFrame;
	
	// Straight from a SwapView example--sorry, but I don't have
	// the example any more, so I can't give credit.  :-(

	thisWindowgstate=[thisWindow gState];
	[[thisWindow contentView] getFrame:&theFrame];
	[[[NXApp appIcon] contentView] lockFocus];
	PScomposite((float)theFrame.origin.x,
		(float)theFrame.origin.y,
		(float)theFrame.size.width,
		(float)theFrame.size.height,
		(int)thisWindowgstate,
		(float)0.0,
		(float)0.0,
		(int)NX_COPY);
	[[[NXApp appIcon] contentView] unlockFocus];
	[[NXApp appIcon] flushWindow];
	NXPing();
	return self;
	}

@end

