//
//	MiscTextExtensions.m -- extensions to the NeXT Text object
//		Originally written by Scott Anguish
//		Copyright (c) 1994 by Scott Anguish.
//		Modified and extended by Don Yacktman for inclusion into the MiscKit.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/misckit.h>

@implementation Text(MiscExtensions)

- (MiscString *)getContentString
{
	NXStream *theStream;
	char *data;
	int length, maxLength;
	MiscString *theString;

	theString = [[MiscString alloc] init];
	theStream = NXOpenMemory(NULL, 0, NX_READWRITE);
	[self writeText:theStream];
	NXPutc(theStream,'\0');
	NXGetMemoryBuffer(theStream, &data, &length, &maxLength);
	[theString setStringValue:data];
	NXClose(theStream);
	return theString;
}
	
	
- (MiscString *)getSelectionString
{
	NXSelPt start, end;

	[self getSel:&start :&end];
	return [self getSubstringStringStart:start.cp length:(end.cp - start.cp)];
}
	
	
- (MiscString *)getSubstringStringStart:(int)startPos length:(int)numChars
{
	int i;
	char *temp = malloc(numChars + 1);
	MiscString *stringObj;

	i = [self getSubstring:temp start:startPos length:numChars];
	temp[i] = '\0'; // make sure it is terminated
	stringObj = [MiscString newWithString:temp];
	free(temp);
	return stringObj;
}

@end

