// Copyright (C) 1995 Jon Kutemeier
// Use is governed by the MiscKit license

#import <appkit/SelectionCell.h>

@class Font;

@interface DateSelectionCell : SelectionCell
{
    NXColor 	textColor,
    		highlightTextColor,
    		backgroundColor,
     		highlightColor;
    Font	*newCellFont;
    BOOL	drawRightEdge,
		drawEntireBottomEdge;
}

- setTextColor:(NXColor)aColor;
- (NXColor)textColor;

- setHighlightTextColor:(NXColor)aColor;
- (NXColor)highlightTextColor;

- setBackgroundColor:(NXColor)aColor;
- (NXColor)backgroundColor;

- setHighlightColor:(NXColor)aColor;
- (NXColor)highlightColor;

- setDrawRightEdge:(BOOL)yn;
- (BOOL)drawRightEdge;

- setDrawEntireBottomEdge:(BOOL)yn;
- (BOOL)drawEntireBottomEdge;

- drawInside:(const NXRect*)cellFrame inView:controlView;
- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag;

- read:(NXTypedStream *)aStream;
- write:(NXTypedStream *)aStream;

@end
