//
//	MiscHalftoneColor.h -- a class for color "tints"  (to specify a halftone)
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscColor.h>

@interface MiscHalftoneColor:MiscColor <NXTransport>
{
	float percent;
}

+ (BOOL)canInitFromPasteboard:(Pasteboard *)pasteboard;
- setFromPasteBoard:(Pasteboard *)pasteboard;
- writeToPasteBoard:(Pasteboard *)pasteboard;
- setHalftone:(float)amount;
- (float)halftone;
- (NXColor)filterColor:(NXColor)input;
- setColorFromObject:object;
- (BOOL)isEqualHalftoneAmount:anObject;
- (BOOL)isEqualColor:anObject;
- (BOOL)isEqual:anObject;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- (const char *)getInspectorClassName;
- (NXImage *)getIBImage;
- setColorFromPixel:(NXPoint *)location;

@end