/*=========================== MiscZoneUTMCoord.h ============================*/
/* MiscZoneUTMCoord class contains and supports values representing locations
   in any zone of the world wide Universal Transverse Mercator coordinate
   system.

   DMA Release 0.8, Copyright @1993 by Genesis Project, Ltd. All Rights
   Reserved. For further information on terms and conditions see
		the MiscKit license.

HISTORY
26-Mar-93  Dale Amon at GPL
	   Created.
*/

#import <appkit/appkit.h>
#import <misckit/miscgiskit.h>

#define	MISC_ZONE_COORD_VERSION_ID	0.8

@interface MiscZoneUTMCoord:MiscUTMCoord
{
	unsigned int	zoneNumber;	/* UTM zone number */
}

+initialize;

-initDescription: (char *) txt zone: (unsigned int) zone;

- awake;
- write:(NXTypedStream *)stream;
- read: (NXTypedStream *)stream;

/* blocked methods */
-initDescription: (char *) txt constants: anObject;

@end
