#
# language.make
# Copyright (C) 1995 Stephan Wacker
# 94-12-25
#
# Put this line into your Makefile.preamble:
#	LOCALMAKEDIR = /LocalDeveloper/Makefiles
#
# And this goes to the end of Makefile.postamble:
#	include $(LOCALMAKEDIR)/language.make
#
# Inputs from Makefile.preamble:
#	OTHER_LANGUAGES - list of languages for which you have written
#		localized resources, e.g.  ``French German Spanish''
#


project:: other_languages_resources

other_languages_resources:
	@( for lang in $(OTHER_LANGUAGES) none ; do \
	    if [ $$lang = "none" ] ; then break; fi ; \
	    $(ECHO) ==== $(NAME): Making other language: $$lang ==== ; \
	    $(MAKE) clean_resources resources \
		"LANGUAGE = $$lang" \
		"PRODUCT_ROOT = $(PRODUCT_ROOT)" \
		"APP_MAKEFILE_DIR = $(APP_MAKEFILE_DIR)" ; \
	done )

clean_resources:: clean_help



$(NAME).copy:: other_languages_copy

other_languages_copy:
	@( for lang in $(OTHER_LANGUAGES) none ; do \
	    if [ $$lang = "none" ] ; then break; fi ; \
	    $(MKDIRS) $(DEST)/$$lang.lproj ; \
	    if [ "$(LOCAL_RESOURCES)" != "" ] ; then \
		$(ECHO) "(cd $$lang.lproj; $(TAR) chf - $(LOCAL_RESOURCES)) | (cd $(DEST)/$$lang.lproj; $(TAR) xf - )" ; \
		(cd $$lang.lproj; $(TAR) chf - $(LOCAL_RESOURCES)) | (cd $(DEST)/$$lang.lproj; $(TAR) xf -) ; \
	    fi ; \
	   done )



#
# compresshelp always complains about files in "*.rtfd~" directories.
# This target (clean_help) must be processed before the resources target.
# This can be achieved by making it a toplevel subcomponent; alas, this will
# not be sufficient if there are other Help directories in subprojects or
# bundles.
#

toplevel_subcomponents:: clean_help

clean_help: 
	@( for d in $(HELP_DIRS) $(OTHER_HELP_DIRS); do \
	    if [ -d $$d ] ; then \
	     find $d -name "*~" -print | xargs $(RM) -rf ; \
	    fi ; \
	   done )


