 
//
// Source file      : CustomMenuInspector.m
// Created by       : gideon@berd
// Created on       : Fri Sep 8 09:40:53 NZST 1995
// RCS File         : $Source: /Ramoth/Black.Albatross/CVS/CustomMenu/CustomMenuInspector.m,v $
// Last modified    : $Date: 1995/09/10 22:38:00 $
// Last modified by : $Author: gideon $
// Current Revision : $Revision: 1.1.1.1 $
//
 
static const char RCSId[] = "$Id: CustomMenuInspector.m,v 1.1.1.1 1995/09/10 22:38:00 gideon Exp $";
 

#import "CustomMenuInspector.h"
#import "CustomMenu.subproj/DraggableMenu.h"
#import "CustomMenu.subproj/CustomMenu.h"

@implementation DraggableMenu(IBSupport)

- (const char *)getInspectorClassName
{
	return "CustomMenuInspector";
}

- (NXImage *)getIBImage
{
	id	idBundle;
	id	idImage;
	char buf[MAXPATHLEN + 1];
	
	idBundle = [NXBundle bundleForClass:[CustomMenuInspector class]];
	[idBundle getPath:buf forResource:"CustomMenu" ofType:"tiff"];
	idImage = [[NXImage alloc] initFromFile:buf];
	
	return idImage;
}

@end

@implementation CustomMenuInspector

- (const char *)version
{
	return RCSId;
}

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    
    bundle = [NXBundle bundleForClass:[DraggableMenu class]];
    [bundle getPath:buf 
            forResource:"CustomMenuInspector" 
            ofType:"nib"];
    [NXApp loadNibFile:buf 
           owner:self 
           withNames:NO 
           fromZone:[self zone]];
    return self;
}

- ok:sender
{
	[object setSaveAndRestore:([saveAndRestoreSwitch intValue]) ? YES : NO];
	return [super ok:sender];
}

- revert:sender
{
	[saveAndRestoreSwitch setIntValue:([object getSaveAndRestore]) ? 1 : 0];
	return [super revert:sender];
}

- (BOOL)wantsButtons		// We don't want the Ok and Revert buttons displayed
{
    return NO;
}

- awakeFromNib
{
	id idBundle = [NXBundle bundleForClass:[self class]];
	NXImage *image;
	char buf[MAXPATHLEN+1];
			
    [idBundle getPath:buf forResource:"CustomMenu" ofType:"tiff"];
	image = [[NXImage alloc] initFromFile:buf];
	[iconButton setImage:image];
	
	[saveAndRestoreSwitch setIntValue:1];
	return self;
}

@end
