
// TablePrinter -- A cover class for DBTableViewPrinter.
//
// By Eric T. Seymour, NeXT Computer, Inc.
//
// This object creates and maintains an instance of DBTableViewPrinter in
// an off screen window.  This was designed primarily for ease of use in IB.
//
// You may freely copy, distribute, and reuse the code in this example.
// NeXT disclaims any warranty of any kind, expressed or  implied, as to its
// fitness for any particular use.
//
// This file looks best when using tabstops of 3.


#import <appkit/appkit.h>

@interface TablePrinter:Object
{
	id		tableView;
	id		printerView;
}

// View get/set methods
- setTableView:table;
- tableView;
- printerView;

// printPSCode cover method
- printPSCode:sender;

// DBTableViewPrinter Cover Methods
- headerBezelToggle:sender;
- forceColorToggle:sender;
- pageNumbersToggle:sender;
- rowNumbersToggle:sender;
- gridLinesToggle:sender;
- selectedRowsToggle:sender;
- startPageNum:sender;
- startRowNum:sender;
- pageNumSeparator:sender;
- rowNumHeader:sender;
- headerTextColor:sender;
- headerBackColor:sender;
- rowNumTextColor:sender;
- rowNumBackColor:sender;
- gridColor:sender;
- pageNumColor:sender;
- backgroundColor:sender;

@end
